package cz.muni.fi.pa165.core.device;

import cz.muni.fi.pa165.core.common.DomainService;
import jakarta.persistence.EntityNotFoundException;
import lombok.Getter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Optional;

@Service
public class DeviceService extends DomainService<Device> {

    @Getter
    private final DeviceRepository repository;

    @Autowired
    public DeviceService(DeviceRepository deviceRepository){
        repository = deviceRepository;
    }

    @Transactional(readOnly = true)
    public Device findById(String id){
        return repository.findById(id)
                .orElseThrow(() -> new EntityNotFoundException("Device with '" + id + "' not found"));
    }

    @Transactional
    public Device update(Device device){
        return repository.update(device)
                .orElseThrow(() -> new EntityNotFoundException("Device with '" + device.getId() + "' not found"));
    }
}
