package cz.muni.fi.pa165.core.smartmeter;

import cz.muni.fi.pa165.core.common.DomainMapper;
import cz.muni.fi.pa165.core.device.Device;
import cz.muni.fi.pa165.model.dto.device.DeviceCreateDto;
import cz.muni.fi.pa165.model.dto.device.DeviceDto;
import cz.muni.fi.pa165.model.dto.device.DeviceUpdateDto;
import cz.muni.fi.pa165.model.dto.smartDevice.SmartMeterCreateDto;
import cz.muni.fi.pa165.model.dto.smartDevice.SmartMeterDto;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;

import java.util.List;

@Mapper
public interface SmartMeterMapper extends DomainMapper<SmartMeter, SmartMeterDto> {
    @Mapping(source = "deviceDto", target = "device")
    SmartMeter fromCreateDto(SmartMeterCreateDto dto);

    @Mapping(source = "deviceDto", target = "device")
    SmartMeter fromDto(SmartMeterDto dto);

    @Mapping(source = "device", target = "deviceDto")
    SmartMeterDto toDto(SmartMeter entity);

    @Mapping(source = "device", target = "deviceDto")
    List<SmartMeterDto> toDtoList(List<SmartMeter> entities);


}
