package cz.muni.fi.pa165.core.smartmeter;

import cz.muni.fi.pa165.core.common.DomainService;
import cz.muni.fi.pa165.core.device.Device;
import jakarta.persistence.EntityNotFoundException;
import lombok.Getter;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class SmartMeterService extends DomainService<SmartMeter> {

    @Getter
    private final SmartMeterRepository repository;

    public SmartMeterService(SmartMeterRepository smartMeterRepository) {
        this.repository = smartMeterRepository;
    }

    @Transactional(readOnly = true)
    public SmartMeter findSmartMeterById(String id){
        return repository.findById(id)
                .orElseThrow(() -> new EntityNotFoundException("SmartMeter with '" + id + "' not found"));
    }
}
