package cz.muni.fi.pa165.core.user;

import cz.muni.fi.pa165.model.dto.user.UserCreateDto;
import cz.muni.fi.pa165.model.dto.user.UserDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/users")
public class UserController {

  private final UserService service;

  private final UserMapper mapper;

  @Autowired
  public UserController(UserService service, UserMapper mapper) {
    this.service = service;
    this.mapper = mapper;
  }

  @GetMapping
  public List<UserDto> findAll() {
    return service.findAll().stream().map(mapper::toDto).toList();
  }

  @GetMapping("/{id}")
  public UserDto find(@PathVariable String id) {
    return mapper.toDto(service.find(id));
  }

  @PostMapping
  public UserDto create(@RequestBody UserCreateDto dto) {
    return mapper.toDto(service.create(mapper.fromCreateDto(dto)));
  }

  // @GetMapping
  // public Result<UserDto> findAll(@RequestParam int page) {
  //  	return mapper.toResult(service.findAll(page));
  // }
}
